\hypertarget{group__util}{\section{util}
\label{group__util}\index{util@{util}}
}


utility module  


\subsection*{Data Structures}
\begin{DoxyCompactItemize}
\item 
struct \hyperlink{structtimlUtilImage}{timl\-Util\-Image}
\item 
struct \hyperlink{structtimlUtilInitializer}{timl\-Util\-Initializer}
\item 
struct \hyperlink{structtimlUtilImageSet}{timl\-Util\-Image\-Set}
\end{DoxyCompactItemize}
\subsection*{Macros}
\begin{DoxyCompactItemize}
\item 
\hypertarget{group__util_gaa800319c343d51dcc2ba62246ad298af}{\#define {\bfseries T\-I\-M\-L\-\_\-\-U\-T\-I\-L\-\_\-\-M\-A\-X\-\_\-\-S\-T\-R}~100}\label{group__util_gaa800319c343d51dcc2ba62246ad298af}

\item 
\hypertarget{group__util_ga775af8da42e4c88c8c19afb00b273654}{\#define {\bfseries T\-I\-M\-L\-\_\-\-U\-T\-I\-L\-\_\-\-P\-I}~3.\-14159265358979323846}\label{group__util_ga775af8da42e4c88c8c19afb00b273654}

\item 
\hypertarget{group__util_ga070b6e6e97816b6fcfd3dee857484693}{\#define {\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-O\-F\-F\-S\-E\-T}~3000}\label{group__util_ga070b6e6e97816b6fcfd3dee857484693}

\end{DoxyCompactItemize}
\subsection*{Enumerations}
\begin{DoxyCompactItemize}
\item 
enum {\bfseries timl\-Util\-Error} \{ \\*
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-N\-U\-L\-L\-\_\-\-P\-T\-R} = E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-O\-F\-F\-S\-E\-T, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-D\-A\-T\-A\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-D\-A\-T\-A\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-L\-A\-B\-E\-L\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
\\*
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-L\-A\-B\-E\-L\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-D\-A\-T\-A\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-D\-A\-T\-A\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-L\-A\-B\-E\-L\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
\\*
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-N\-I\-S\-T\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-L\-A\-B\-E\-L\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R10\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R10\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R10\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
\\*
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R10\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R100\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R100\-\_\-\-T\-R\-A\-I\-N\-I\-N\-G\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R100\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-R\-E\-A\-D\-I\-N\-G}, 
\\*
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-C\-I\-F\-A\-R100\-\_\-\-T\-E\-S\-T\-I\-N\-G\-\_\-\-A\-L\-L\-O\-C\-A\-T\-I\-O\-N}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-R\-E\-A\-D\-\_\-\-F\-L\-O\-A\-T\-\_\-\-M\-A\-T\-R\-I\-X}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-R\-E\-A\-D\-\_\-\-I\-N\-T\-\_\-\-M\-A\-T\-R\-I\-X}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-R\-E\-A\-D\-\_\-\-F\-L\-O\-A\-T\-\_\-\-V\-E\-C\-T\-O\-R}, 
\\*
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-R\-E\-A\-D\-\_\-\-I\-N\-T\-\_\-\-V\-E\-C\-T\-O\-R}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-W\-R\-I\-T\-E\-\_\-\-F\-L\-O\-A\-T\-\_\-\-M\-A\-T\-R\-I\-X}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-W\-R\-I\-T\-E\-\_\-\-I\-N\-T\-\_\-\-M\-A\-T\-R\-I\-X}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-W\-R\-I\-T\-E\-\_\-\-F\-L\-O\-A\-T\-\_\-\-V\-E\-C\-T\-O\-R}, 
\\*
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-W\-R\-I\-T\-E\-\_\-\-I\-N\-T\-\_\-\-V\-E\-C\-T\-O\-R}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-M\-A\-L\-L\-O\-C}, 
{\bfseries E\-R\-R\-O\-R\-\_\-\-U\-T\-I\-L\-\_\-\-J\-P\-E\-G\-\_\-\-R\-E\-A\-D\-I\-N\-G}
 \}
\item 
enum {\bfseries timl\-Util\-Activation\-Type} \{ \\*
{\bfseries Util\-\_\-\-Sigmoid}, 
{\bfseries Util\-\_\-\-Softmax}, 
{\bfseries Util\-\_\-\-Softplus}, 
{\bfseries Util\-\_\-\-Relu}, 
\\*
{\bfseries Util\-\_\-\-Nrelu}, 
{\bfseries Util\-\_\-\-Tanh}, 
{\bfseries Util\-\_\-\-Linear}
 \}
\item 
enum {\bfseries timl\-Util\-Cost\-Function\-Type} \{ {\bfseries Util\-\_\-\-Cross\-Entropy}, 
{\bfseries Util\-\_\-\-M\-S\-E}
 \}
\item 
enum {\bfseries timl\-Util\-Conv\-Type} \{ {\bfseries Util\-\_\-\-Conv2\-D}, 
{\bfseries Util\-\_\-\-Corr2\-D}
 \}
\item 
enum \hyperlink{group__util_ga8e44b2a87636024736da04ae5a53c1c9}{timl\-Util\-Params\-Level} \{ \hyperlink{group__util_gga8e44b2a87636024736da04ae5a53c1c9a7a706ba3c48e3e4f1302c8fc5af3bb50}{Util\-\_\-\-Params\-Level1}, 
\hyperlink{group__util_gga8e44b2a87636024736da04ae5a53c1c9a2cddbb23ea76ecaee590b53dab026432}{Util\-\_\-\-Params\-Level2}, 
\hyperlink{group__util_gga8e44b2a87636024736da04ae5a53c1c9adfa1c162a9ac296e6e94e6a03b5ccef5}{Util\-\_\-\-Params\-Level3}
 \}
\item 
enum \hyperlink{group__util_ga62247c3acaa170e3a75f9887ec21106f}{timl\-Util\-Allocator\-Level} \{ \hyperlink{group__util_gga62247c3acaa170e3a75f9887ec21106fabaf43a2a2db7a39b88ca28b3fbdb9f8d}{Util\-\_\-\-Allocator\-Level1}, 
\hyperlink{group__util_gga62247c3acaa170e3a75f9887ec21106fa852397275a536af52c736403647721c3}{Util\-\_\-\-Allocator\-Level2}, 
\hyperlink{group__util_gga62247c3acaa170e3a75f9887ec21106faaa6f2cd7843572787572085b7bef172b}{Util\-\_\-\-Allocator\-Level3}
 \}
\item 
enum \hyperlink{group__util_ga898df2504b88d834c373082f2aa9f537}{timl\-Util\-Crop\-Type} \{ \hyperlink{group__util_gga898df2504b88d834c373082f2aa9f537ae92f4e5d3672f4d40cb213ac3a2210b3}{Util\-\_\-\-Center\-Crop}, 
\hyperlink{group__util_gga898df2504b88d834c373082f2aa9f537ac82205e1f2c21d90dbcccd0e8a7d0dc8}{Util\-\_\-\-Random\-Crop}
 \}
\item 
enum \hyperlink{group__util_ga5405b012e02035f4d864e0e38d516764}{timl\-Util\-Mirror\-Type} \{ \hyperlink{group__util_gga5405b012e02035f4d864e0e38d516764abfa2a07e6c5c6e74add533dfc9b548dd}{Util\-\_\-\-Mirror}, 
\hyperlink{group__util_gga5405b012e02035f4d864e0e38d516764aa4b22e60f0d512a27496c274c01adab6}{Util\-\_\-\-No\-Mirror}, 
\hyperlink{group__util_gga5405b012e02035f4d864e0e38d516764a8ece193f7f7681a69b4b286983583cfc}{Util\-\_\-\-Random\-Mirror}
 \}
\item 
enum {\bfseries timl\-Util\-Initializer\-Type} \{ {\bfseries Util\-\_\-\-Constant}, 
{\bfseries Util\-\_\-\-Gaussian}, 
{\bfseries Util\-\_\-\-Uniform}, 
{\bfseries Util\-\_\-\-Xavier}
 \}
\item 
enum {\bfseries timl\-Util\-Phase} \{ {\bfseries Util\-\_\-\-Train}, 
{\bfseries Util\-\_\-\-Test}, 
{\bfseries Util\-\_\-\-Debug}
 \}
\end{DoxyCompactItemize}
\subsection*{Functions}
\begin{DoxyCompactItemize}
\item 
int \hyperlink{group__util_ga218c4e1b952545e65e70b46fc087c0fa}{timl\-Util\-Read\-M\-N\-I\-S\-T} (const char $\ast$path, \hyperlink{structtimlUtilImageSet}{timl\-Util\-Image\-Set} $\ast$training, \hyperlink{structtimlUtilImageSet}{timl\-Util\-Image\-Set} $\ast$testing)
\begin{DoxyCompactList}\small\item\em Read M\-N\-I\-S\-T database from binary files. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga518889e2bee0ffe2a0bab1a2a509afeb}{timl\-Util\-Read\-C\-I\-F\-A\-R10} (const char $\ast$path, \hyperlink{structtimlUtilImageSet}{timl\-Util\-Image\-Set} $\ast$training, \hyperlink{structtimlUtilImageSet}{timl\-Util\-Image\-Set} $\ast$testing)
\begin{DoxyCompactList}\small\item\em Read C\-I\-F\-A10 database from binary files. \end{DoxyCompactList}\item 
long \hyperlink{group__util_gad332b3fc9cca905cb073bb950c27d9a3}{timl\-Util\-Diff\-Time} (struct timespec start, struct timespec end)
\begin{DoxyCompactList}\small\item\em Return the time difference in micro second. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga7b7056163efcce74e844159113ad7670}{timl\-Util\-Rand\-Discrete\-Uniform\-R\-N\-G} (int a, int b)
\begin{DoxyCompactList}\small\item\em Discrete uniform random number generator in \mbox{[}a, b\mbox{]}. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga33ca8bcccfd95381c34a7822dd3d5e03}{timl\-Util\-Rand\-Continuous\-Uniform\-R\-N\-G} (float $\ast$x, int dim, float a, float b)
\begin{DoxyCompactList}\small\item\em Generate a discrete uniform random vector between (a, b) \end{DoxyCompactList}\item 
int \hyperlink{group__util_gab0d103f2a7348ee3f7be2468cb06a374}{timl\-Util\-Rand\-Normal\-R\-N\-G} (float $\ast$x, int dim, float mean, float std)
\begin{DoxyCompactList}\small\item\em Generate a Gaussian random number. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga33f6226602545ae82fb9eb9dc4e2d0f4}{timl\-Util\-Rand\-Perm} (int $\ast$array, int n)
\begin{DoxyCompactList}\small\item\em Random permute an array. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga032c2a840544aee29ac1b36494bdfc6b}{timl\-Util\-Fread} (void $\ast$ptr, size\-\_\-t size, size\-\_\-t nmemb, F\-I\-L\-E $\ast$fp)
\begin{DoxyCompactList}\small\item\em Read binary file. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gad27678810eff89cf1f813631d762b298}{timl\-Util\-Fwrite} (const void $\ast$ptr, size\-\_\-t size, size\-\_\-t nmemb, F\-I\-L\-E $\ast$fp)
\begin{DoxyCompactList}\small\item\em Write to a binar file. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gafdc65cff28dd8132ee12d7e4fff6b344}{timl\-Util\-Conv2\-Valid} (float $\ast$a, float $\ast$b, float $\ast$c, int a\-Row, int a\-Col, int b\-Row, int b\-Col)
\begin{DoxyCompactList}\small\item\em conv2(a, b, 'valid') \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga825fca95dc612cb50cca8d3b42fce451}{timl\-Util\-Conv2\-Full} (float $\ast$a, float $\ast$b, float $\ast$c, int a\-Row, int a\-Col, int b\-Row, int b\-Col)
\begin{DoxyCompactList}\small\item\em conv2(a, b, 'full') \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga76c854493ff6e686e70caf0e0f330694}{timl\-Util\-Corr2\-Full} (float $\ast$a, float $\ast$b, float $\ast$c, int a\-Row, int a\-Col, int b\-Row, int b\-Col)
\begin{DoxyCompactList}\small\item\em conv2(a, rot90(b,2), 'valid') \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga823c056e72e3c9738ba07232a759dd93}{timl\-Util\-Conv2\-Image\-Reshape\-Back} (float $\ast$x, float $\ast$x\-Reshape, int $\ast$index, int channel, int x\-Dim, int index\-Dim, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Reshape the convolution matrix back to feature maps. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga5bed0ba528735cfa363c12de22b30fae}{timl\-Util\-Conv2\-Image\-Reshape\-Index} (int $\ast$index, int a\-Row, int a\-Col, int b\-Row, int b\-Col, int pad\-Up, int pad\-Down, int pad\-Left, int pad\-Right, int stride\-X, int stride\-Y, timl\-Util\-Conv\-Type type)
\begin{DoxyCompactList}\small\item\em Create a reshaping index matrix. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga1a6a5d975df7c8d4ef7ca184cbb98293}{timl\-Util\-Conv2\-Image\-Reshape} (float $\ast$x\-Reshape, float $\ast$x, int $\ast$index, int channel, int x\-Dim, int index\-Dim, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Reshape feature maps to a format that turns 2d convolution to G\-E\-M\-M operation. \end{DoxyCompactList}\item 
\hyperlink{structtimlUtilImage}{timl\-Util\-Image} \hyperlink{group__util_ga6e186bf4e96a71fd1bc88aa79a7fd7f9}{timl\-Util\-Read\-J\-P\-E\-G} (const char $\ast$name)
\begin{DoxyCompactList}\small\item\em read a jpg image \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga4e3a2beb9a301e6c71f5c1df09d6099e}{timl\-Util\-Read\-Fixed\-Size\-J\-P\-E\-G} (const char $\ast$name, float $\ast$data, int row, int col, int channel)
\begin{DoxyCompactList}\small\item\em Read a jpg image with known size information to avoid frequent allocation and deallocation of data. \end{DoxyCompactList}\item 
char $\ast$$\ast$ \hyperlink{group__util_ga3cb2f6d77b727af3d819f75c6918c327}{timl\-Util\-Scan\-J\-P\-E\-G} (const char $\ast$dir\-Name, int $\ast$image\-Num)
\begin{DoxyCompactList}\small\item\em Return an array of jpg image names in the directory. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga365f20b5c810059087f2d24964ec7fdd}{void \hyperlink{group__util_ga365f20b5c810059087f2d24964ec7fdd}{timl\-Util\-B\-L\-A\-Sdgemm} (const enum C\-B\-L\-A\-S\-\_\-\-T\-R\-A\-N\-S\-P\-O\-S\-E Trans\-A, const enum C\-B\-L\-A\-S\-\_\-\-T\-R\-A\-N\-S\-P\-O\-S\-E Trans\-B, const int M, const int N, const int K, const double alpha, const double $\ast$A, const double $\ast$B, const double beta, double $\ast$C, int device\-Id, int thread\-Id)}\label{group__util_ga365f20b5c810059087f2d24964ec7fdd}

\begin{DoxyCompactList}\small\item\em Double general matrix matrix multiplication C = alpha $\ast$ op(\-A) $\ast$ op(\-B) + beta $\ast$ C op(\-A) \-: M$\ast$\-K op(\-B) \-: K$\ast$\-N. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga3cd3b5eb20373a30eb06e1db3f27e105}{void \hyperlink{group__util_ga3cd3b5eb20373a30eb06e1db3f27e105}{timl\-Util\-B\-L\-A\-Ssgemm} (const enum C\-B\-L\-A\-S\-\_\-\-T\-R\-A\-N\-S\-P\-O\-S\-E Trans\-A, const enum C\-B\-L\-A\-S\-\_\-\-T\-R\-A\-N\-S\-P\-O\-S\-E Trans\-B, const int M, const int N, const int K, const float alpha, const float $\ast$A, const float $\ast$B, const float beta, float $\ast$C, int device\-Id, int thread\-Id)}\label{group__util_ga3cd3b5eb20373a30eb06e1db3f27e105}

\begin{DoxyCompactList}\small\item\em Float general matrix matrix multiplication C = alpha $\ast$ op(\-A) $\ast$ op(\-B) + beta $\ast$ C op(\-A) \-: M$\ast$\-K op(\-B) \-: K$\ast$\-N. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga7f200e1630837f410457f12228a3f8e3}{void \hyperlink{group__util_ga7f200e1630837f410457f12228a3f8e3}{timl\-Util\-B\-L\-A\-Sdgemv} (const enum C\-B\-L\-A\-S\-\_\-\-T\-R\-A\-N\-S\-P\-O\-S\-E Trans\-A, const int M, const int N, const double alpha, const double $\ast$A, const double $\ast$x, const double beta, double $\ast$y, int device\-Id, int thread\-Id)}\label{group__util_ga7f200e1630837f410457f12228a3f8e3}

\begin{DoxyCompactList}\small\item\em Double general matrix vector multiplication y = alpha $\ast$ op(\-A) $\ast$ x + beta $\ast$ y op(\-A)\-: M$\ast$\-N. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga916c002835a135384e25aa4eabe8fece}{void \hyperlink{group__util_ga916c002835a135384e25aa4eabe8fece}{timl\-Util\-B\-L\-A\-Ssgemv} (const enum C\-B\-L\-A\-S\-\_\-\-T\-R\-A\-N\-S\-P\-O\-S\-E Trans\-A, const int M, const int N, const float alpha, const float $\ast$A, const float $\ast$x, const float beta, float $\ast$y, int device\-Id, int thread\-Id)}\label{group__util_ga916c002835a135384e25aa4eabe8fece}

\begin{DoxyCompactList}\small\item\em Float general matrix vector multiplication y = alpha $\ast$ op(\-A) $\ast$ x + beta $\ast$ y op(\-A)\-: M$\ast$\-N. \end{DoxyCompactList}\item 
\hypertarget{group__util_gace6d95139cce2b66d468b65916d92103}{void \hyperlink{group__util_gace6d95139cce2b66d468b65916d92103}{timl\-Util\-B\-L\-A\-Ssaxpy} (const int N, const float alpha, const float $\ast$X, float $\ast$Y, int device\-Id, int thread\-Id)}\label{group__util_gace6d95139cce2b66d468b65916d92103}

\begin{DoxyCompactList}\small\item\em Float vector addition Y = alpha $\ast$ X + Y. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga67a8b8821e100476544c39ebe3f7d88a}{void \hyperlink{group__util_ga67a8b8821e100476544c39ebe3f7d88a}{timl\-Util\-B\-L\-A\-Sdaxpy} (const int N, const double alpha, const double $\ast$X, double $\ast$Y, int device\-Id, int thread\-Id)}\label{group__util_ga67a8b8821e100476544c39ebe3f7d88a}

\begin{DoxyCompactList}\small\item\em Double vector addition Y = alpha $\ast$ X + Y. \end{DoxyCompactList}\item 
\hypertarget{group__util_gae2c99812143fb0697fad81b04c62545d}{void \hyperlink{group__util_gae2c99812143fb0697fad81b04c62545d}{timl\-Util\-B\-L\-A\-Sscopy} (const int N, const float $\ast$X, float $\ast$Y, int device\-Id, int thread\-Id)}\label{group__util_gae2c99812143fb0697fad81b04c62545d}

\begin{DoxyCompactList}\small\item\em Float vector copy Y = X. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga242d2f4bb422b71fa05aec4b8568bdc4}{void \hyperlink{group__util_ga242d2f4bb422b71fa05aec4b8568bdc4}{timl\-Util\-B\-L\-A\-Sdcopy} (const int N, const double $\ast$X, double $\ast$Y, int device\-Id, int thread\-Id)}\label{group__util_ga242d2f4bb422b71fa05aec4b8568bdc4}

\begin{DoxyCompactList}\small\item\em Double vector copy Y = X. \end{DoxyCompactList}\item 
\hypertarget{group__util_gacdd02957d16d4ba4951f35c0e7fc5b30}{void \hyperlink{group__util_gacdd02957d16d4ba4951f35c0e7fc5b30}{timl\-Util\-B\-L\-A\-Ssger} (const int M, const int N, const float alpha, float $\ast$x, float $\ast$y, float $\ast$A, int device\-Id, int thread\-Id)}\label{group__util_gacdd02957d16d4ba4951f35c0e7fc5b30}

\begin{DoxyCompactList}\small\item\em Float vector outer product A = alpha$\ast$x$\ast$y' + A; x\-: M y\-: N. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga22f1d9ebb3a5745c3583860b42c8590a}{void \hyperlink{group__util_ga22f1d9ebb3a5745c3583860b42c8590a}{timl\-Util\-B\-L\-A\-Sdger} (const int M, const int N, const double alpha, double $\ast$x, double $\ast$y, double $\ast$A, int device\-Id, int thread\-Id)}\label{group__util_ga22f1d9ebb3a5745c3583860b42c8590a}

\begin{DoxyCompactList}\small\item\em Double vector outer product A = alpha$\ast$x$\ast$y' + A; x\-: M y\-: N. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga336682df712eb1342b16a00731b55e2c}{void \hyperlink{group__util_ga336682df712eb1342b16a00731b55e2c}{timl\-Util\-B\-L\-A\-Sdscal} (const int N, const double alpha, double $\ast$X, int device\-Id, int thread\-Id)}\label{group__util_ga336682df712eb1342b16a00731b55e2c}

\begin{DoxyCompactList}\small\item\em Double vector scaling x = alpha $\ast$ x. \end{DoxyCompactList}\item 
\hypertarget{group__util_ga7f2ccf0e4a749d484cd40b64d14a0bdb}{void \hyperlink{group__util_ga7f2ccf0e4a749d484cd40b64d14a0bdb}{timl\-Util\-B\-L\-A\-Ssscal} (const int N, const float alpha, float $\ast$X, int device\-Id, int thread\-Id)}\label{group__util_ga7f2ccf0e4a749d484cd40b64d14a0bdb}

\begin{DoxyCompactList}\small\item\em Float vector scaling x = alpha $\ast$ x. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga4c8737cc28dfcafb340a06869cb06c6d}{timl\-Util\-Vector\-Reset\-Float} (float $\ast$a, int m, float val, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Reset a float vector. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga105ed091f1ed14bc4542117639799727}{timl\-Util\-Vector\-Reset\-Int} (int $\ast$a, int m, int val, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Reset an int vector. \end{DoxyCompactList}\item 
float \hyperlink{group__util_ga50c739176cce0504f24f414d1abe03de}{timl\-Util\-Vector\-Sum\-Float} (float $\ast$a, int n)
\begin{DoxyCompactList}\small\item\em Calculate the sum of a float vector. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gadbfd41f459cef267ff705fbed1a684de}{timl\-Util\-Vector\-Sort\-Float} (float $\ast$a, int n)
\begin{DoxyCompactList}\small\item\em Sort an array in descending order. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga7adedb39838d1a724329c2f05e70d2bc}{timl\-Util\-Vector\-Sort\-Index\-Float} (float $\ast$a, int $\ast$index, int n)
\begin{DoxyCompactList}\small\item\em Sort an array in descending order and return the indices of the original elements in the sorted array. \end{DoxyCompactList}\item 
float \hyperlink{group__util_ga80375ed4d8c895a5373c0ea5bea7c90c}{timl\-Util\-Vector\-Max\-Float} (float $\ast$x, int n, int inc)
\begin{DoxyCompactList}\small\item\em Return the max value in the array. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga2e09d42235ce01dc8d951cac92ccce28}{timl\-Util\-Vector\-Max\-Index\-Float} (float $\ast$x, int n, int inc)
\begin{DoxyCompactList}\small\item\em Return the max value index in the array. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga4cbc9e168ae6fe4be792e5700078fbfd}{timl\-Util\-Element\-Wise\-Multiply} (float $\ast$a, const float $\ast$b, const float $\ast$c, int dim, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Element wise multiply c = a.$\ast$b. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga158d5bed50c9d1aa04f3437ba4e4746c}{timl\-Util\-Subtract} (float $\ast$x, float y, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Subtract operation. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga0e3ab1684d55ae10ec96b1b7a58c2d0f}{timl\-Util\-Sigmoid} (float $\ast$x, float $\ast$y, int n, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Sigmoid. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gac4ce5d2a827d4d0bddb092604dc22555}{timl\-Util\-Sigmoid\-Derivative} (float $\ast$x, float $\ast$y, int n, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Sigmoid derivative. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gaf61206d55b45c89e3382ed9684ef2c79}{timl\-Util\-Relu} (float $\ast$x, float $\ast$y, int n, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Rectified linear unit. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gadcb6e562a1ddebb9589dc326c6e85db3}{timl\-Util\-Relu\-Derivative} (float $\ast$x, float $\ast$y, int n, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Rectified linear unit derivative. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga680fe5b84f1ce4712c74fc9c01b5dc82}{timl\-Util\-Tanh\-Derivative} (float $\ast$x, float $\ast$y, int n, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Tanh derivative. \end{DoxyCompactList}\item 
float \hyperlink{group__util_gac8848759ff2638e9b54beef8f82748ae}{timl\-Util\-Multinomial\-Cross\-Entropy} (float $\ast$x, int label, int n)
\begin{DoxyCompactList}\small\item\em Calculate the mutlinomial cross entropy between x and label. \end{DoxyCompactList}\item 
float \hyperlink{group__util_ga8e17bdb2dd7b9e8f25d1a93c8d470a97}{timl\-Util\-Mean\-Sqaure\-Error} (float $\ast$x, int label, int n)
\begin{DoxyCompactList}\small\item\em Calculate the mean square error between x and label. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga223537dde56b8c21a9455ff8a635f71f}{timl\-Util\-Softmax} (float $\ast$x, float $\ast$y, int row, int col, int channel, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Softmax function. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga64e5197e9d131870e97cd510b3f499ac}{timl\-Util\-Classify\-Accuracy} (int $\ast$label, int top\-N, int num, int $\ast$true\-Label)
\begin{DoxyCompactList}\small\item\em Calculate the classification accuracy. \end{DoxyCompactList}\item 
void \hyperlink{group__util_ga6bc3609f73f6674134821cc002d7081f}{timl\-Util\-Transform} (float $\ast$data\-Out, float $\ast$data\-In, float $\ast$data\-Host, int channel, int row, int col, int row\-Offset, int col\-Offset, int row\-In, int col\-In, float scale, float $\ast$mean, \hyperlink{group__util_ga5405b012e02035f4d864e0e38d516764}{timl\-Util\-Mirror\-Type} mirror\-Type, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Transform the raw input data with preprocessing. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gac9523e1013f8e3853568eb2e67b54a58}{timl\-Util\-Max\-Pooling} (float $\ast$output\-Map, int $\ast$max\-Index, float $\ast$input\-Map, int row, int col, int channel, int prev\-Row, int prev\-Col, int scale\-Row, int scale\-Col, int pad\-Up, int pad\-Left, int stride\-X, int stride\-Y, timl\-Util\-Phase phase, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Max pooling. \end{DoxyCompactList}\item 
int \hyperlink{group__util_gae073107f6b111717bac95417ff80c85c}{timl\-Util\-Undo\-Max\-Pooling} (float $\ast$prev\-Delta, int $\ast$max\-Index, float $\ast$delta, int dim, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Undo max pooling. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga8d4338ebfb64ecb3ec88094aebd65e40}{timl\-Util\-Mean\-Pooling} (float $\ast$output\-Map, float $\ast$input\-Map, int row, int col, int channel, int prev\-Row, int prev\-Col, int scale\-Row, int scale\-Col, int pad\-Up, int pad\-Left, int stride\-X, int stride\-Y, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Mean pooling. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga47ba59c5e11f31931e3fae5717b93450}{timl\-Util\-Undo\-Mean\-Pooling} (float $\ast$prev\-Delta, float $\ast$delta, int row, int col, int channel, int prev\-Row, int prev\-Col, int scale\-Row, int scale\-Col, int pad\-Up, int pad\-Left, int stride\-X, int stride\-Y, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Undo mean pooling. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga1d68b304f7ad43899cf5a2762a0a49fc}{timl\-Util\-Local\-Contrast\-Normalize} (float $\ast$input\-Map, float $\ast$output\-Map, float $\ast$denom, int row, int col, int channel, int N, float alpha, float beta, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Local contrast normalization. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga684bafa4cb678d451ec1aa5127007470}{timl\-Util\-Local\-Contrast\-Unnormalize} (float $\ast$prev\-Delta, float $\ast$prev\-Feature\-Map, float $\ast$delta, float $\ast$feature\-Map, float $\ast$denom, int row, int col, int channel, int N, float alpha, float beta, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Local contrast unnormalization. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga4b2ab842a2212e924deb9f60bf1b703e}{timl\-Util\-Masking} (float $\ast$input\-Map, float $\ast$output\-Map, int $\ast$mask, unsigned int $\ast$random\-Vector, int dim, float prob, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Masking feature maps. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga7e53789a132ed94665d66a10dd9ff76c}{timl\-Util\-Unmasking} (float $\ast$input\-Delta, float $\ast$output\-Delta, int $\ast$mask, int dim, float prob, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Masking feature maps. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga26bb1805bd3475719324718c12cd5a0f}{timl\-Util\-Tanh} (float $\ast$x, float $\ast$y, int n, int device\-Id, int thread\-Id)
\begin{DoxyCompactList}\small\item\em Tanh. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga432784c912b542452d7236cf72d184fe}{timl\-Util\-Malloc} (void $\ast$$\ast$dev\-Ptr, size\-\_\-t size)
\begin{DoxyCompactList}\small\item\em memory allocation \end{DoxyCompactList}\item 
void \hyperlink{group__util_ga234f6573583aca626c49e10b1f5b57d2}{timl\-Util\-Free} (void $\ast$ptr)
\begin{DoxyCompactList}\small\item\em Free pointer. \end{DoxyCompactList}\item 
uint32\-\_\-t \hyperlink{group__util_ga16f8b9181ff6ce6d4b1f655a5eb4738e}{timl\-Util\-Reverse\-Endian32} (register uint32\-\_\-t i)
\begin{DoxyCompactList}\small\item\em Reverse the 32 bit endian pattern. \end{DoxyCompactList}\item 
int \hyperlink{group__util_ga71557afaf0c3d8359920380558dd92fb}{timl\-Util\-Element\-Wise\-Function} (float $\ast$x, float $\ast$y, int n, float($\ast$func)(float))
\begin{DoxyCompactList}\small\item\em Apply a function on each element of the array. \end{DoxyCompactList}\end{DoxyCompactItemize}


\subsection{Detailed Description}
utility module 

\subsection{Enumeration Type Documentation}
\hypertarget{group__util_ga62247c3acaa170e3a75f9887ec21106f}{\index{util@{util}!timl\-Util\-Allocator\-Level@{timl\-Util\-Allocator\-Level}}
\index{timl\-Util\-Allocator\-Level@{timl\-Util\-Allocator\-Level}!util@{util}}
\subsubsection[{timl\-Util\-Allocator\-Level}]{\setlength{\rightskip}{0pt plus 5cm}enum {\bf timl\-Util\-Allocator\-Level}}}\label{group__util_ga62247c3acaa170e3a75f9887ec21106f}
\begin{Desc}
\item[Enumerator]\par
\begin{description}
\index{Util\-\_\-\-Allocator\-Level1@{Util\-\_\-\-Allocator\-Level1}!util@{util}}\index{util@{util}!Util\-\_\-\-Allocator\-Level1@{Util\-\_\-\-Allocator\-Level1}}\item[{\em 
\hypertarget{group__util_gga62247c3acaa170e3a75f9887ec21106fabaf43a2a2db7a39b88ca28b3fbdb9f8d}{Util\-\_\-\-Allocator\-Level1}\label{group__util_gga62247c3acaa170e3a75f9887ec21106fabaf43a2a2db7a39b88ca28b3fbdb9f8d}
}]training mode \index{Util\-\_\-\-Allocator\-Level2@{Util\-\_\-\-Allocator\-Level2}!util@{util}}\index{util@{util}!Util\-\_\-\-Allocator\-Level2@{Util\-\_\-\-Allocator\-Level2}}\item[{\em 
\hypertarget{group__util_gga62247c3acaa170e3a75f9887ec21106fa852397275a536af52c736403647721c3}{Util\-\_\-\-Allocator\-Level2}\label{group__util_gga62247c3acaa170e3a75f9887ec21106fa852397275a536af52c736403647721c3}
}]testing mode \index{Util\-\_\-\-Allocator\-Level3@{Util\-\_\-\-Allocator\-Level3}!util@{util}}\index{util@{util}!Util\-\_\-\-Allocator\-Level3@{Util\-\_\-\-Allocator\-Level3}}\item[{\em 
\hypertarget{group__util_gga62247c3acaa170e3a75f9887ec21106faaa6f2cd7843572787572085b7bef172b}{Util\-\_\-\-Allocator\-Level3}\label{group__util_gga62247c3acaa170e3a75f9887ec21106faaa6f2cd7843572787572085b7bef172b}
}]testing mode with memory pool \end{description}
\end{Desc}
\hypertarget{group__util_ga898df2504b88d834c373082f2aa9f537}{\index{util@{util}!timl\-Util\-Crop\-Type@{timl\-Util\-Crop\-Type}}
\index{timl\-Util\-Crop\-Type@{timl\-Util\-Crop\-Type}!util@{util}}
\subsubsection[{timl\-Util\-Crop\-Type}]{\setlength{\rightskip}{0pt plus 5cm}enum {\bf timl\-Util\-Crop\-Type}}}\label{group__util_ga898df2504b88d834c373082f2aa9f537}
\begin{Desc}
\item[Enumerator]\par
\begin{description}
\index{Util\-\_\-\-Center\-Crop@{Util\-\_\-\-Center\-Crop}!util@{util}}\index{util@{util}!Util\-\_\-\-Center\-Crop@{Util\-\_\-\-Center\-Crop}}\item[{\em 
\hypertarget{group__util_gga898df2504b88d834c373082f2aa9f537ae92f4e5d3672f4d40cb213ac3a2210b3}{Util\-\_\-\-Center\-Crop}\label{group__util_gga898df2504b88d834c373082f2aa9f537ae92f4e5d3672f4d40cb213ac3a2210b3}
}]crop the picture at the center \index{Util\-\_\-\-Random\-Crop@{Util\-\_\-\-Random\-Crop}!util@{util}}\index{util@{util}!Util\-\_\-\-Random\-Crop@{Util\-\_\-\-Random\-Crop}}\item[{\em 
\hypertarget{group__util_gga898df2504b88d834c373082f2aa9f537ac82205e1f2c21d90dbcccd0e8a7d0dc8}{Util\-\_\-\-Random\-Crop}\label{group__util_gga898df2504b88d834c373082f2aa9f537ac82205e1f2c21d90dbcccd0e8a7d0dc8}
}]randomly crop the picture \end{description}
\end{Desc}
\hypertarget{group__util_ga5405b012e02035f4d864e0e38d516764}{\index{util@{util}!timl\-Util\-Mirror\-Type@{timl\-Util\-Mirror\-Type}}
\index{timl\-Util\-Mirror\-Type@{timl\-Util\-Mirror\-Type}!util@{util}}
\subsubsection[{timl\-Util\-Mirror\-Type}]{\setlength{\rightskip}{0pt plus 5cm}enum {\bf timl\-Util\-Mirror\-Type}}}\label{group__util_ga5405b012e02035f4d864e0e38d516764}
\begin{Desc}
\item[Enumerator]\par
\begin{description}
\index{Util\-\_\-\-Mirror@{Util\-\_\-\-Mirror}!util@{util}}\index{util@{util}!Util\-\_\-\-Mirror@{Util\-\_\-\-Mirror}}\item[{\em 
\hypertarget{group__util_gga5405b012e02035f4d864e0e38d516764abfa2a07e6c5c6e74add533dfc9b548dd}{Util\-\_\-\-Mirror}\label{group__util_gga5405b012e02035f4d864e0e38d516764abfa2a07e6c5c6e74add533dfc9b548dd}
}]mirror the picture \index{Util\-\_\-\-No\-Mirror@{Util\-\_\-\-No\-Mirror}!util@{util}}\index{util@{util}!Util\-\_\-\-No\-Mirror@{Util\-\_\-\-No\-Mirror}}\item[{\em 
\hypertarget{group__util_gga5405b012e02035f4d864e0e38d516764aa4b22e60f0d512a27496c274c01adab6}{Util\-\_\-\-No\-Mirror}\label{group__util_gga5405b012e02035f4d864e0e38d516764aa4b22e60f0d512a27496c274c01adab6}
}]do not mirror the picture \index{Util\-\_\-\-Random\-Mirror@{Util\-\_\-\-Random\-Mirror}!util@{util}}\index{util@{util}!Util\-\_\-\-Random\-Mirror@{Util\-\_\-\-Random\-Mirror}}\item[{\em 
\hypertarget{group__util_gga5405b012e02035f4d864e0e38d516764a8ece193f7f7681a69b4b286983583cfc}{Util\-\_\-\-Random\-Mirror}\label{group__util_gga5405b012e02035f4d864e0e38d516764a8ece193f7f7681a69b4b286983583cfc}
}]randomly mirror the picture according to Bernoulli(0,1) \end{description}
\end{Desc}
\hypertarget{group__util_ga8e44b2a87636024736da04ae5a53c1c9}{\index{util@{util}!timl\-Util\-Params\-Level@{timl\-Util\-Params\-Level}}
\index{timl\-Util\-Params\-Level@{timl\-Util\-Params\-Level}!util@{util}}
\subsubsection[{timl\-Util\-Params\-Level}]{\setlength{\rightskip}{0pt plus 5cm}enum {\bf timl\-Util\-Params\-Level}}}\label{group__util_ga8e44b2a87636024736da04ae5a53c1c9}
\begin{Desc}
\item[Enumerator]\par
\begin{description}
\index{Util\-\_\-\-Params\-Level1@{Util\-\_\-\-Params\-Level1}!util@{util}}\index{util@{util}!Util\-\_\-\-Params\-Level1@{Util\-\_\-\-Params\-Level1}}\item[{\em 
\hypertarget{group__util_gga8e44b2a87636024736da04ae5a53c1c9a7a706ba3c48e3e4f1302c8fc5af3bb50}{Util\-\_\-\-Params\-Level1}\label{group__util_gga8e44b2a87636024736da04ae5a53c1c9a7a706ba3c48e3e4f1302c8fc5af3bb50}
}]structure text file only \index{Util\-\_\-\-Params\-Level2@{Util\-\_\-\-Params\-Level2}!util@{util}}\index{util@{util}!Util\-\_\-\-Params\-Level2@{Util\-\_\-\-Params\-Level2}}\item[{\em 
\hypertarget{group__util_gga8e44b2a87636024736da04ae5a53c1c9a2cddbb23ea76ecaee590b53dab026432}{Util\-\_\-\-Params\-Level2}\label{group__util_gga8e44b2a87636024736da04ae5a53c1c9a2cddbb23ea76ecaee590b53dab026432}
}]structure text + parameter binary \index{Util\-\_\-\-Params\-Level3@{Util\-\_\-\-Params\-Level3}!util@{util}}\index{util@{util}!Util\-\_\-\-Params\-Level3@{Util\-\_\-\-Params\-Level3}}\item[{\em 
\hypertarget{group__util_gga8e44b2a87636024736da04ae5a53c1c9adfa1c162a9ac296e6e94e6a03b5ccef5}{Util\-\_\-\-Params\-Level3}\label{group__util_gga8e44b2a87636024736da04ae5a53c1c9adfa1c162a9ac296e6e94e6a03b5ccef5}
}]structure text + parameter binary + state binary \end{description}
\end{Desc}


\subsection{Function Documentation}
\hypertarget{group__util_ga64e5197e9d131870e97cd510b3f499ac}{\index{util@{util}!timl\-Util\-Classify\-Accuracy@{timl\-Util\-Classify\-Accuracy}}
\index{timl\-Util\-Classify\-Accuracy@{timl\-Util\-Classify\-Accuracy}!util@{util}}
\subsubsection[{timl\-Util\-Classify\-Accuracy}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Classify\-Accuracy (
\begin{DoxyParamCaption}
\item[{int $\ast$}]{label, }
\item[{int}]{top\-N, }
\item[{int}]{num, }
\item[{int $\ast$}]{true\-Label}
\end{DoxyParamCaption}
)}}\label{group__util_ga64e5197e9d131870e97cd510b3f499ac}


Calculate the classification accuracy. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em label} & Label matrix, size = num$\ast$top\-N \\
\hline
\mbox{\tt in}  & {\em top\-N} & Top N labels \\
\hline
\mbox{\tt in}  & {\em num} & Number of samples \\
\hline
\mbox{\tt in}  & {\em true\-Label} & True label array, size = num \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Total number of correct labels 
\end{DoxyReturn}
\hypertarget{group__util_ga825fca95dc612cb50cca8d3b42fce451}{\index{util@{util}!timl\-Util\-Conv2\-Full@{timl\-Util\-Conv2\-Full}}
\index{timl\-Util\-Conv2\-Full@{timl\-Util\-Conv2\-Full}!util@{util}}
\subsubsection[{timl\-Util\-Conv2\-Full}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Conv2\-Full (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{float $\ast$}]{b, }
\item[{float $\ast$}]{c, }
\item[{int}]{a\-Row, }
\item[{int}]{a\-Col, }
\item[{int}]{b\-Row, }
\item[{int}]{b\-Col}
\end{DoxyParamCaption}
)}}\label{group__util_ga825fca95dc612cb50cca8d3b42fce451}


conv2(a, b, 'full') 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em a} & \\
\hline
\mbox{\tt in}  & {\em b} & \\
\hline
\mbox{\tt out}  & {\em c} & c = conv2(a, b, 'full') \\
\hline
\mbox{\tt in}  & {\em a\-Row} & a row size \\
\hline
\mbox{\tt in}  & {\em a\-Col} & c col size \\
\hline
\mbox{\tt in}  & {\em b\-Row} & b row size \\
\hline
\mbox{\tt in}  & {\em b\-Col} & b col size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga1a6a5d975df7c8d4ef7ca184cbb98293}{\index{util@{util}!timl\-Util\-Conv2\-Image\-Reshape@{timl\-Util\-Conv2\-Image\-Reshape}}
\index{timl\-Util\-Conv2\-Image\-Reshape@{timl\-Util\-Conv2\-Image\-Reshape}!util@{util}}
\subsubsection[{timl\-Util\-Conv2\-Image\-Reshape}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Conv2\-Image\-Reshape (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x\-Reshape, }
\item[{float $\ast$}]{x, }
\item[{int $\ast$}]{index, }
\item[{int}]{channel, }
\item[{int}]{x\-Dim, }
\item[{int}]{index\-Dim, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga1a6a5d975df7c8d4ef7ca184cbb98293}


Reshape feature maps to a format that turns 2d convolution to G\-E\-M\-M operation. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em x\-Reshape} & Reshaped feature map \\
\hline
\mbox{\tt in}  & {\em x} & Feature map \\
\hline
\mbox{\tt in}  & {\em index} & Reshaping index matrix \\
\hline
\mbox{\tt in}  & {\em channel} & The number of channels in the feature maps \\
\hline
\mbox{\tt in}  & {\em x\-Dim} & Dimension of the feature map (row$\ast$col) \\
\hline
\mbox{\tt in}  & {\em index\-Dim} & Dimension of the index matrix \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga823c056e72e3c9738ba07232a759dd93}{\index{util@{util}!timl\-Util\-Conv2\-Image\-Reshape\-Back@{timl\-Util\-Conv2\-Image\-Reshape\-Back}}
\index{timl\-Util\-Conv2\-Image\-Reshape\-Back@{timl\-Util\-Conv2\-Image\-Reshape\-Back}!util@{util}}
\subsubsection[{timl\-Util\-Conv2\-Image\-Reshape\-Back}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Conv2\-Image\-Reshape\-Back (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{x\-Reshape, }
\item[{int $\ast$}]{index, }
\item[{int}]{channel, }
\item[{int}]{x\-Dim, }
\item[{int}]{index\-Dim, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga823c056e72e3c9738ba07232a759dd93}


Reshape the convolution matrix back to feature maps. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & feature map \\
\hline
\mbox{\tt out}  & {\em x\-Reshape} & Reshaped feature map \\
\hline
\mbox{\tt in}  & {\em index} & Reshaping index matrix \\
\hline
\mbox{\tt in}  & {\em channel} & The number of channels in the feature map \\
\hline
\mbox{\tt in}  & {\em x\-Dim} & Dimension of the feature map (row$\ast$col) \\
\hline
\mbox{\tt in}  & {\em index\-Dim} & Dimension of the index matrix \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga5bed0ba528735cfa363c12de22b30fae}{\index{util@{util}!timl\-Util\-Conv2\-Image\-Reshape\-Index@{timl\-Util\-Conv2\-Image\-Reshape\-Index}}
\index{timl\-Util\-Conv2\-Image\-Reshape\-Index@{timl\-Util\-Conv2\-Image\-Reshape\-Index}!util@{util}}
\subsubsection[{timl\-Util\-Conv2\-Image\-Reshape\-Index}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Conv2\-Image\-Reshape\-Index (
\begin{DoxyParamCaption}
\item[{int $\ast$}]{index, }
\item[{int}]{a\-Row, }
\item[{int}]{a\-Col, }
\item[{int}]{b\-Row, }
\item[{int}]{b\-Col, }
\item[{int}]{pad\-Up, }
\item[{int}]{pad\-Down, }
\item[{int}]{pad\-Left, }
\item[{int}]{pad\-Right, }
\item[{int}]{stride\-X, }
\item[{int}]{stride\-Y, }
\item[{timl\-Util\-Conv\-Type}]{type}
\end{DoxyParamCaption}
)}}\label{group__util_ga5bed0ba528735cfa363c12de22b30fae}


Create a reshaping index matrix. 

Feature maps need to be reshaped so that a 2d convolution can be converted to a G\-E\-M\-M operation. The reshaping index matrix records the index mapping between the original feature maps and the reshaped feature maps 
\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em index} & Reshaping index matrix \\
\hline
\mbox{\tt in}  & {\em a\-Row} & Feature map row \\
\hline
\mbox{\tt in}  & {\em a\-Col} & Feature map col \\
\hline
\mbox{\tt in}  & {\em b\-Row} & Kernel row \\
\hline
\mbox{\tt in}  & {\em b\-Col} & Kernel col \\
\hline
\mbox{\tt in}  & {\em pad\-Up} & Padding for the up border of the image \\
\hline
\mbox{\tt in}  & {\em pad\-Down} & Padding for the down border of the image \\
\hline
\mbox{\tt in}  & {\em pad\-Left} & Padding for the left border of the image \\
\hline
\mbox{\tt in}  & {\em pad\-Right} & Padding for the right border of the image \\
\hline
\mbox{\tt in}  & {\em stride\-X} & Horizontal stride for the kernel \\
\hline
\mbox{\tt in}  & {\em stride\-Y} & Vertical stride for the kernel \\
\hline
\mbox{\tt in}  & {\em type} & Convolution or correlation \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gafdc65cff28dd8132ee12d7e4fff6b344}{\index{util@{util}!timl\-Util\-Conv2\-Valid@{timl\-Util\-Conv2\-Valid}}
\index{timl\-Util\-Conv2\-Valid@{timl\-Util\-Conv2\-Valid}!util@{util}}
\subsubsection[{timl\-Util\-Conv2\-Valid}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Conv2\-Valid (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{float $\ast$}]{b, }
\item[{float $\ast$}]{c, }
\item[{int}]{a\-Row, }
\item[{int}]{a\-Col, }
\item[{int}]{b\-Row, }
\item[{int}]{b\-Col}
\end{DoxyParamCaption}
)}}\label{group__util_gafdc65cff28dd8132ee12d7e4fff6b344}


conv2(a, b, 'valid') 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em a} & a matrix \\
\hline
\mbox{\tt in}  & {\em b} & b matrix \\
\hline
\mbox{\tt out}  & {\em c} & c = conv2(a, b, 'valid') \\
\hline
\mbox{\tt in}  & {\em a\-Row} & a row size \\
\hline
\mbox{\tt in}  & {\em a\-Col} & a col size \\
\hline
\mbox{\tt in}  & {\em b\-Row} & b row size \\
\hline
\mbox{\tt in}  & {\em b\-Col} & b col size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga76c854493ff6e686e70caf0e0f330694}{\index{util@{util}!timl\-Util\-Corr2\-Full@{timl\-Util\-Corr2\-Full}}
\index{timl\-Util\-Corr2\-Full@{timl\-Util\-Corr2\-Full}!util@{util}}
\subsubsection[{timl\-Util\-Corr2\-Full}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Corr2\-Full (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{float $\ast$}]{b, }
\item[{float $\ast$}]{c, }
\item[{int}]{a\-Row, }
\item[{int}]{a\-Col, }
\item[{int}]{b\-Row, }
\item[{int}]{b\-Col}
\end{DoxyParamCaption}
)}}\label{group__util_ga76c854493ff6e686e70caf0e0f330694}


conv2(a, rot90(b,2), 'valid') 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em a} & a matrix \\
\hline
\mbox{\tt in}  & {\em b} & b matrix \\
\hline
\mbox{\tt out}  & {\em c} & c = conv2(a, rot90(b,2), 'valid') \\
\hline
\mbox{\tt in}  & {\em a\-Row} & a row size \\
\hline
\mbox{\tt in}  & {\em a\-Col} & a col size \\
\hline
\mbox{\tt in}  & {\em b\-Row} & b row size \\
\hline
\mbox{\tt in}  & {\em b\-Col} & b col size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gad332b3fc9cca905cb073bb950c27d9a3}{\index{util@{util}!timl\-Util\-Diff\-Time@{timl\-Util\-Diff\-Time}}
\index{timl\-Util\-Diff\-Time@{timl\-Util\-Diff\-Time}!util@{util}}
\subsubsection[{timl\-Util\-Diff\-Time}]{\setlength{\rightskip}{0pt plus 5cm}long timl\-Util\-Diff\-Time (
\begin{DoxyParamCaption}
\item[{struct timespec}]{start, }
\item[{struct timespec}]{end}
\end{DoxyParamCaption}
)}}\label{group__util_gad332b3fc9cca905cb073bb950c27d9a3}


Return the time difference in micro second. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em start} & Start time \\
\hline
\mbox{\tt in}  & {\em end} & End time return Time difference \\
\hline
\end{DoxyParams}
\hypertarget{group__util_ga71557afaf0c3d8359920380558dd92fb}{\index{util@{util}!timl\-Util\-Element\-Wise\-Function@{timl\-Util\-Element\-Wise\-Function}}
\index{timl\-Util\-Element\-Wise\-Function@{timl\-Util\-Element\-Wise\-Function}!util@{util}}
\subsubsection[{timl\-Util\-Element\-Wise\-Function}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Element\-Wise\-Function (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{n, }
\item[{float($\ast$)(float)}]{func}
\end{DoxyParamCaption}
)}}\label{group__util_ga71557afaf0c3d8359920380558dd92fb}


Apply a function on each element of the array. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input array \\
\hline
\mbox{\tt out}  & {\em y} & Output array \\
\hline
\mbox{\tt in}  & {\em n} & Array size \\
\hline
\mbox{\tt in}  & {\em func} & Function pointer \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga4cbc9e168ae6fe4be792e5700078fbfd}{\index{util@{util}!timl\-Util\-Element\-Wise\-Multiply@{timl\-Util\-Element\-Wise\-Multiply}}
\index{timl\-Util\-Element\-Wise\-Multiply@{timl\-Util\-Element\-Wise\-Multiply}!util@{util}}
\subsubsection[{timl\-Util\-Element\-Wise\-Multiply}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Element\-Wise\-Multiply (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{const float $\ast$}]{b, }
\item[{const float $\ast$}]{c, }
\item[{int}]{dim, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga4cbc9e168ae6fe4be792e5700078fbfd}


Element wise multiply c = a.$\ast$b. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em a} & a vector \\
\hline
\mbox{\tt in}  & {\em b} & b vector \\
\hline
\mbox{\tt out}  & {\em c} & c = a.$\ast$b \\
\hline
\mbox{\tt in}  & {\em dim} & Dimension of a,b,c \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga032c2a840544aee29ac1b36494bdfc6b}{\index{util@{util}!timl\-Util\-Fread@{timl\-Util\-Fread}}
\index{timl\-Util\-Fread@{timl\-Util\-Fread}!util@{util}}
\subsubsection[{timl\-Util\-Fread}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Fread (
\begin{DoxyParamCaption}
\item[{void $\ast$}]{ptr, }
\item[{size\-\_\-t}]{size, }
\item[{size\-\_\-t}]{nmemb, }
\item[{F\-I\-L\-E $\ast$}]{fp}
\end{DoxyParamCaption}
)}}\label{group__util_ga032c2a840544aee29ac1b36494bdfc6b}


Read binary file. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em ptr} & Pointer \\
\hline
\mbox{\tt in}  & {\em size} & Size of array \\
\hline
\mbox{\tt in}  & {\em nmemb} & Array element size \\
\hline
\mbox{\tt in}  & {\em fp} & File pointer \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
The number of successfully read elements 
\end{DoxyReturn}
\hypertarget{group__util_ga234f6573583aca626c49e10b1f5b57d2}{\index{util@{util}!timl\-Util\-Free@{timl\-Util\-Free}}
\index{timl\-Util\-Free@{timl\-Util\-Free}!util@{util}}
\subsubsection[{timl\-Util\-Free}]{\setlength{\rightskip}{0pt plus 5cm}void timl\-Util\-Free (
\begin{DoxyParamCaption}
\item[{void $\ast$}]{ptr}
\end{DoxyParamCaption}
)}}\label{group__util_ga234f6573583aca626c49e10b1f5b57d2}


Free pointer. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em ptr} & Memory pointer \\
\hline
\end{DoxyParams}
\hypertarget{group__util_gad27678810eff89cf1f813631d762b298}{\index{util@{util}!timl\-Util\-Fwrite@{timl\-Util\-Fwrite}}
\index{timl\-Util\-Fwrite@{timl\-Util\-Fwrite}!util@{util}}
\subsubsection[{timl\-Util\-Fwrite}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Fwrite (
\begin{DoxyParamCaption}
\item[{const void $\ast$}]{ptr, }
\item[{size\-\_\-t}]{size, }
\item[{size\-\_\-t}]{nmemb, }
\item[{F\-I\-L\-E $\ast$}]{fp}
\end{DoxyParamCaption}
)}}\label{group__util_gad27678810eff89cf1f813631d762b298}


Write to a binar file. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em ptr} & Memory pointer \\
\hline
\mbox{\tt in}  & {\em size} & Array size \\
\hline
\mbox{\tt in}  & {\em nmemb} & Array element size \\
\hline
\mbox{\tt in}  & {\em fp} & File pointer \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Number of successfully written elements 
\end{DoxyReturn}
\hypertarget{group__util_ga1d68b304f7ad43899cf5a2762a0a49fc}{\index{util@{util}!timl\-Util\-Local\-Contrast\-Normalize@{timl\-Util\-Local\-Contrast\-Normalize}}
\index{timl\-Util\-Local\-Contrast\-Normalize@{timl\-Util\-Local\-Contrast\-Normalize}!util@{util}}
\subsubsection[{timl\-Util\-Local\-Contrast\-Normalize}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Local\-Contrast\-Normalize (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{input\-Map, }
\item[{float $\ast$}]{output\-Map, }
\item[{float $\ast$}]{denom, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{channel, }
\item[{int}]{N, }
\item[{float}]{alpha, }
\item[{float}]{beta, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga1d68b304f7ad43899cf5a2762a0a49fc}


Local contrast normalization. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em input\-Map} & Input feature map \\
\hline
\mbox{\tt out}  & {\em output\-Map} & Output feature map \\
\hline
\mbox{\tt out}  & {\em denom} & Feature map denom \\
\hline
\mbox{\tt in}  & {\em row} & Input feature map row \\
\hline
\mbox{\tt in}  & {\em col} & Input feature map col \\
\hline
\mbox{\tt in}  & {\em channel} & Input feature map channel \\
\hline
\mbox{\tt in}  & {\em N} & Channel span \\
\hline
\mbox{\tt in}  & {\em alpha} & Alpha \\
\hline
\mbox{\tt in}  & {\em beta} & Beta \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga684bafa4cb678d451ec1aa5127007470}{\index{util@{util}!timl\-Util\-Local\-Contrast\-Unnormalize@{timl\-Util\-Local\-Contrast\-Unnormalize}}
\index{timl\-Util\-Local\-Contrast\-Unnormalize@{timl\-Util\-Local\-Contrast\-Unnormalize}!util@{util}}
\subsubsection[{timl\-Util\-Local\-Contrast\-Unnormalize}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Local\-Contrast\-Unnormalize (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{prev\-Delta, }
\item[{float $\ast$}]{prev\-Feature\-Map, }
\item[{float $\ast$}]{delta, }
\item[{float $\ast$}]{feature\-Map, }
\item[{float $\ast$}]{denom, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{channel, }
\item[{int}]{N, }
\item[{float}]{alpha, }
\item[{float}]{beta, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga684bafa4cb678d451ec1aa5127007470}


Local contrast unnormalization. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em prev\-Delta} & Previous delta \\
\hline
\mbox{\tt in}  & {\em prev\-Feature\-Map} & Previous feature map \\
\hline
\mbox{\tt in}  & {\em delta} & Delta \\
\hline
\mbox{\tt in}  & {\em feature\-Map} & Feature map \\
\hline
\mbox{\tt in}  & {\em denom} & Feature map denom \\
\hline
\mbox{\tt in}  & {\em row} & Feature map row \\
\hline
\mbox{\tt in}  & {\em col} & Feature map col \\
\hline
\mbox{\tt in}  & {\em channel} & Feature map channel \\
\hline
\mbox{\tt in}  & {\em N} & Channel span \\
\hline
\mbox{\tt in}  & {\em alpha} & Alpha \\
\hline
\mbox{\tt in}  & {\em beta} & Beta \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga432784c912b542452d7236cf72d184fe}{\index{util@{util}!timl\-Util\-Malloc@{timl\-Util\-Malloc}}
\index{timl\-Util\-Malloc@{timl\-Util\-Malloc}!util@{util}}
\subsubsection[{timl\-Util\-Malloc}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Malloc (
\begin{DoxyParamCaption}
\item[{void $\ast$$\ast$}]{dev\-Ptr, }
\item[{size\-\_\-t}]{size}
\end{DoxyParamCaption}
)}}\label{group__util_ga432784c912b542452d7236cf72d184fe}


memory allocation 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in,out}  & {\em dev\-Ptr} & device ptr \\
\hline
\mbox{\tt in}  & {\em size} & allocation size in byte \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
error code 
\end{DoxyReturn}
\hypertarget{group__util_ga4b2ab842a2212e924deb9f60bf1b703e}{\index{util@{util}!timl\-Util\-Masking@{timl\-Util\-Masking}}
\index{timl\-Util\-Masking@{timl\-Util\-Masking}!util@{util}}
\subsubsection[{timl\-Util\-Masking}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Masking (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{input\-Map, }
\item[{float $\ast$}]{output\-Map, }
\item[{int $\ast$}]{mask, }
\item[{unsigned int $\ast$}]{random\-Vector, }
\item[{int}]{dim, }
\item[{float}]{prob, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga4b2ab842a2212e924deb9f60bf1b703e}


Masking feature maps. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em input\-Map} & Input feature map \\
\hline
\mbox{\tt out}  & {\em output\-Map} & Output feature map \\
\hline
\mbox{\tt out}  & {\em mask} & Mask vector of values \{0,1\} \\
\hline
\mbox{\tt in}  & {\em random\-Vector} & A uniform random vector in \mbox{[}0,1\mbox{]} \\
\hline
\mbox{\tt in}  & {\em dim} & Dimension of the feature map (row$\ast$col$\ast$channel) \\
\hline
\mbox{\tt in}  & {\em prob} & Dropout probability \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gac9523e1013f8e3853568eb2e67b54a58}{\index{util@{util}!timl\-Util\-Max\-Pooling@{timl\-Util\-Max\-Pooling}}
\index{timl\-Util\-Max\-Pooling@{timl\-Util\-Max\-Pooling}!util@{util}}
\subsubsection[{timl\-Util\-Max\-Pooling}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Max\-Pooling (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{output\-Map, }
\item[{int $\ast$}]{max\-Index, }
\item[{float $\ast$}]{input\-Map, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{channel, }
\item[{int}]{prev\-Row, }
\item[{int}]{prev\-Col, }
\item[{int}]{scale\-Row, }
\item[{int}]{scale\-Col, }
\item[{int}]{pad\-Up, }
\item[{int}]{pad\-Left, }
\item[{int}]{stride\-X, }
\item[{int}]{stride\-Y, }
\item[{timl\-Util\-Phase}]{phase, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_gac9523e1013f8e3853568eb2e67b54a58}


Max pooling. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em output\-Map} & Output feature map \\
\hline
\mbox{\tt in}  & {\em max\-Index} & Max value index map \\
\hline
\mbox{\tt in}  & {\em input\-Map} & Input feature map \\
\hline
\mbox{\tt in}  & {\em row} & Output feature map row \\
\hline
\mbox{\tt in}  & {\em col} & Output feature map col \\
\hline
\mbox{\tt in}  & {\em channel} & Output feature map channel \\
\hline
\mbox{\tt in}  & {\em prev\-Row} & Previous feature map row \\
\hline
\mbox{\tt in}  & {\em prev\-Col} & Previous feature map col \\
\hline
\mbox{\tt in}  & {\em scale\-Row} & Scaling window row size \\
\hline
\mbox{\tt in}  & {\em scale\-Col} & Scaling window col size \\
\hline
\mbox{\tt in}  & {\em pad\-Up} & Upper border padding for the input feature map \\
\hline
\mbox{\tt in}  & {\em pad\-Left} & Left border padding for the input feature map \\
\hline
\mbox{\tt in}  & {\em stride\-X} & Window stride in x direction \\
\hline
\mbox{\tt in}  & {\em stride\-Y} & Window stride in y direction \\
\hline
\mbox{\tt in}  & {\em phase} & C\-N\-N phase \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga8d4338ebfb64ecb3ec88094aebd65e40}{\index{util@{util}!timl\-Util\-Mean\-Pooling@{timl\-Util\-Mean\-Pooling}}
\index{timl\-Util\-Mean\-Pooling@{timl\-Util\-Mean\-Pooling}!util@{util}}
\subsubsection[{timl\-Util\-Mean\-Pooling}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Mean\-Pooling (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{output\-Map, }
\item[{float $\ast$}]{input\-Map, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{channel, }
\item[{int}]{prev\-Row, }
\item[{int}]{prev\-Col, }
\item[{int}]{scale\-Row, }
\item[{int}]{scale\-Col, }
\item[{int}]{pad\-Up, }
\item[{int}]{pad\-Left, }
\item[{int}]{stride\-X, }
\item[{int}]{stride\-Y, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga8d4338ebfb64ecb3ec88094aebd65e40}


Mean pooling. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em output\-Map} & Output feature map \\
\hline
\mbox{\tt in}  & {\em input\-Map} & Input feature map \\
\hline
\mbox{\tt in}  & {\em row} & Output feature map row \\
\hline
\mbox{\tt in}  & {\em col} & Output feature map col \\
\hline
\mbox{\tt in}  & {\em channel} & Output feature map channel \\
\hline
\mbox{\tt in}  & {\em prev\-Row} & Previous feature map row \\
\hline
\mbox{\tt in}  & {\em prev\-Col} & Previous feature map col \\
\hline
\mbox{\tt in}  & {\em scale\-Row} & Scaling window row size \\
\hline
\mbox{\tt in}  & {\em scale\-Col} & Scaling window col size \\
\hline
\mbox{\tt in}  & {\em pad\-Up} & Upper border padding for the input feature map \\
\hline
\mbox{\tt in}  & {\em pad\-Left} & Left border padding for the input feature map \\
\hline
\mbox{\tt in}  & {\em stride\-X} & Window stride in x direction \\
\hline
\mbox{\tt in}  & {\em stride\-Y} & Window stride in y direction \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga8e17bdb2dd7b9e8f25d1a93c8d470a97}{\index{util@{util}!timl\-Util\-Mean\-Sqaure\-Error@{timl\-Util\-Mean\-Sqaure\-Error}}
\index{timl\-Util\-Mean\-Sqaure\-Error@{timl\-Util\-Mean\-Sqaure\-Error}!util@{util}}
\subsubsection[{timl\-Util\-Mean\-Sqaure\-Error}]{\setlength{\rightskip}{0pt plus 5cm}float timl\-Util\-Mean\-Sqaure\-Error (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{int}]{label, }
\item[{int}]{n}
\end{DoxyParamCaption}
)}}\label{group__util_ga8e17bdb2dd7b9e8f25d1a93c8d470a97}


Calculate the mean square error between x and label. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input data \\
\hline
\mbox{\tt in}  & {\em label} & Label \\
\hline
\mbox{\tt in}  & {\em n} & Data size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Mean square error 
\end{DoxyReturn}
\hypertarget{group__util_gac8848759ff2638e9b54beef8f82748ae}{\index{util@{util}!timl\-Util\-Multinomial\-Cross\-Entropy@{timl\-Util\-Multinomial\-Cross\-Entropy}}
\index{timl\-Util\-Multinomial\-Cross\-Entropy@{timl\-Util\-Multinomial\-Cross\-Entropy}!util@{util}}
\subsubsection[{timl\-Util\-Multinomial\-Cross\-Entropy}]{\setlength{\rightskip}{0pt plus 5cm}float timl\-Util\-Multinomial\-Cross\-Entropy (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{int}]{label, }
\item[{int}]{n}
\end{DoxyParamCaption}
)}}\label{group__util_gac8848759ff2638e9b54beef8f82748ae}


Calculate the mutlinomial cross entropy between x and label. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input data \\
\hline
\mbox{\tt in}  & {\em label} & Label \\
\hline
\mbox{\tt in}  & {\em n} & Data size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Cross entropy 
\end{DoxyReturn}
\hypertarget{group__util_ga33ca8bcccfd95381c34a7822dd3d5e03}{\index{util@{util}!timl\-Util\-Rand\-Continuous\-Uniform\-R\-N\-G@{timl\-Util\-Rand\-Continuous\-Uniform\-R\-N\-G}}
\index{timl\-Util\-Rand\-Continuous\-Uniform\-R\-N\-G@{timl\-Util\-Rand\-Continuous\-Uniform\-R\-N\-G}!util@{util}}
\subsubsection[{timl\-Util\-Rand\-Continuous\-Uniform\-R\-N\-G}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Rand\-Continuous\-Uniform\-R\-N\-G (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{int}]{dim, }
\item[{float}]{a, }
\item[{float}]{b}
\end{DoxyParamCaption}
)}}\label{group__util_ga33ca8bcccfd95381c34a7822dd3d5e03}


Generate a discrete uniform random vector between (a, b) 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Generated random vector \\
\hline
\mbox{\tt in}  & {\em dim} & Dimension \\
\hline
\mbox{\tt in}  & {\em a} & Lower bound \\
\hline
\mbox{\tt in}  & {\em b} & Upper bound \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Random vector 
\end{DoxyReturn}
\hypertarget{group__util_ga7b7056163efcce74e844159113ad7670}{\index{util@{util}!timl\-Util\-Rand\-Discrete\-Uniform\-R\-N\-G@{timl\-Util\-Rand\-Discrete\-Uniform\-R\-N\-G}}
\index{timl\-Util\-Rand\-Discrete\-Uniform\-R\-N\-G@{timl\-Util\-Rand\-Discrete\-Uniform\-R\-N\-G}!util@{util}}
\subsubsection[{timl\-Util\-Rand\-Discrete\-Uniform\-R\-N\-G}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Rand\-Discrete\-Uniform\-R\-N\-G (
\begin{DoxyParamCaption}
\item[{int}]{a, }
\item[{int}]{b}
\end{DoxyParamCaption}
)}}\label{group__util_ga7b7056163efcce74e844159113ad7670}


Discrete uniform random number generator in \mbox{[}a, b\mbox{]}. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em a} & Lower bound \\
\hline
\mbox{\tt in}  & {\em b} & Upper bound \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Random integer 
\end{DoxyReturn}
\hypertarget{group__util_gab0d103f2a7348ee3f7be2468cb06a374}{\index{util@{util}!timl\-Util\-Rand\-Normal\-R\-N\-G@{timl\-Util\-Rand\-Normal\-R\-N\-G}}
\index{timl\-Util\-Rand\-Normal\-R\-N\-G@{timl\-Util\-Rand\-Normal\-R\-N\-G}!util@{util}}
\subsubsection[{timl\-Util\-Rand\-Normal\-R\-N\-G}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Rand\-Normal\-R\-N\-G (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{int}]{dim, }
\item[{float}]{mean, }
\item[{float}]{std}
\end{DoxyParamCaption}
)}}\label{group__util_gab0d103f2a7348ee3f7be2468cb06a374}


Generate a Gaussian random number. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em x} & Guassian random vector \\
\hline
\mbox{\tt in}  & {\em dim} & Vector dimension \\
\hline
\mbox{\tt in}  & {\em mean} & Mean \\
\hline
\mbox{\tt in}  & {\em std} & Standard deviation \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga33f6226602545ae82fb9eb9dc4e2d0f4}{\index{util@{util}!timl\-Util\-Rand\-Perm@{timl\-Util\-Rand\-Perm}}
\index{timl\-Util\-Rand\-Perm@{timl\-Util\-Rand\-Perm}!util@{util}}
\subsubsection[{timl\-Util\-Rand\-Perm}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Rand\-Perm (
\begin{DoxyParamCaption}
\item[{int $\ast$}]{array, }
\item[{int}]{n}
\end{DoxyParamCaption}
)}}\label{group__util_ga33f6226602545ae82fb9eb9dc4e2d0f4}


Random permute an array. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in,out}  & {\em array} & Array \\
\hline
\mbox{\tt in}  & {\em n} & Array size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga518889e2bee0ffe2a0bab1a2a509afeb}{\index{util@{util}!timl\-Util\-Read\-C\-I\-F\-A\-R10@{timl\-Util\-Read\-C\-I\-F\-A\-R10}}
\index{timl\-Util\-Read\-C\-I\-F\-A\-R10@{timl\-Util\-Read\-C\-I\-F\-A\-R10}!util@{util}}
\subsubsection[{timl\-Util\-Read\-C\-I\-F\-A\-R10}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Read\-C\-I\-F\-A\-R10 (
\begin{DoxyParamCaption}
\item[{const char $\ast$}]{path, }
\item[{{\bf timl\-Util\-Image\-Set} $\ast$}]{training, }
\item[{{\bf timl\-Util\-Image\-Set} $\ast$}]{testing}
\end{DoxyParamCaption}
)}}\label{group__util_ga518889e2bee0ffe2a0bab1a2a509afeb}


Read C\-I\-F\-A10 database from binary files. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em training} & Training database \\
\hline
\mbox{\tt out}  & {\em testing} & Testing database \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga4e3a2beb9a301e6c71f5c1df09d6099e}{\index{util@{util}!timl\-Util\-Read\-Fixed\-Size\-J\-P\-E\-G@{timl\-Util\-Read\-Fixed\-Size\-J\-P\-E\-G}}
\index{timl\-Util\-Read\-Fixed\-Size\-J\-P\-E\-G@{timl\-Util\-Read\-Fixed\-Size\-J\-P\-E\-G}!util@{util}}
\subsubsection[{timl\-Util\-Read\-Fixed\-Size\-J\-P\-E\-G}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Read\-Fixed\-Size\-J\-P\-E\-G (
\begin{DoxyParamCaption}
\item[{const char $\ast$}]{name, }
\item[{float $\ast$}]{data, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{channel}
\end{DoxyParamCaption}
)}}\label{group__util_ga4e3a2beb9a301e6c71f5c1df09d6099e}


Read a jpg image with known size information to avoid frequent allocation and deallocation of data. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em name} & Image name \\
\hline
\mbox{\tt out}  & {\em data} & Data \\
\hline
\mbox{\tt in}  & {\em row} & Row \\
\hline
\mbox{\tt in}  & {\em col} & Col \\
\hline
\mbox{\tt in}  & {\em channel} & Channel \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga6e186bf4e96a71fd1bc88aa79a7fd7f9}{\index{util@{util}!timl\-Util\-Read\-J\-P\-E\-G@{timl\-Util\-Read\-J\-P\-E\-G}}
\index{timl\-Util\-Read\-J\-P\-E\-G@{timl\-Util\-Read\-J\-P\-E\-G}!util@{util}}
\subsubsection[{timl\-Util\-Read\-J\-P\-E\-G}]{\setlength{\rightskip}{0pt plus 5cm}{\bf timl\-Util\-Image} timl\-Util\-Read\-J\-P\-E\-G (
\begin{DoxyParamCaption}
\item[{const char $\ast$}]{name}
\end{DoxyParamCaption}
)}}\label{group__util_ga6e186bf4e96a71fd1bc88aa79a7fd7f9}


read a jpg image 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em name} & image name \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
\hyperlink{structtimlUtilImage}{timl\-Util\-Image} structure 
\end{DoxyReturn}
\hypertarget{group__util_ga218c4e1b952545e65e70b46fc087c0fa}{\index{util@{util}!timl\-Util\-Read\-M\-N\-I\-S\-T@{timl\-Util\-Read\-M\-N\-I\-S\-T}}
\index{timl\-Util\-Read\-M\-N\-I\-S\-T@{timl\-Util\-Read\-M\-N\-I\-S\-T}!util@{util}}
\subsubsection[{timl\-Util\-Read\-M\-N\-I\-S\-T}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Read\-M\-N\-I\-S\-T (
\begin{DoxyParamCaption}
\item[{const char $\ast$}]{path, }
\item[{{\bf timl\-Util\-Image\-Set} $\ast$}]{training, }
\item[{{\bf timl\-Util\-Image\-Set} $\ast$}]{testing}
\end{DoxyParamCaption}
)}}\label{group__util_ga218c4e1b952545e65e70b46fc087c0fa}


Read M\-N\-I\-S\-T database from binary files. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em path} & Database path \\
\hline
\mbox{\tt out}  & {\em training} & Training database \\
\hline
\mbox{\tt out}  & {\em testing} & Testing database \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gaf61206d55b45c89e3382ed9684ef2c79}{\index{util@{util}!timl\-Util\-Relu@{timl\-Util\-Relu}}
\index{timl\-Util\-Relu@{timl\-Util\-Relu}!util@{util}}
\subsubsection[{timl\-Util\-Relu}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Relu (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{n, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_gaf61206d55b45c89e3382ed9684ef2c79}


Rectified linear unit. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input \\
\hline
\mbox{\tt out}  & {\em y} & Outupt \\
\hline
\mbox{\tt in}  & {\em n} & Input size \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gadcb6e562a1ddebb9589dc326c6e85db3}{\index{util@{util}!timl\-Util\-Relu\-Derivative@{timl\-Util\-Relu\-Derivative}}
\index{timl\-Util\-Relu\-Derivative@{timl\-Util\-Relu\-Derivative}!util@{util}}
\subsubsection[{timl\-Util\-Relu\-Derivative}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Relu\-Derivative (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{n, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_gadcb6e562a1ddebb9589dc326c6e85db3}


Rectified linear unit derivative. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input \\
\hline
\mbox{\tt out}  & {\em y} & Derivative of relu(x) \\
\hline
\mbox{\tt in}  & {\em n} & Input size \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga16f8b9181ff6ce6d4b1f655a5eb4738e}{\index{util@{util}!timl\-Util\-Reverse\-Endian32@{timl\-Util\-Reverse\-Endian32}}
\index{timl\-Util\-Reverse\-Endian32@{timl\-Util\-Reverse\-Endian32}!util@{util}}
\subsubsection[{timl\-Util\-Reverse\-Endian32}]{\setlength{\rightskip}{0pt plus 5cm}uint32\-\_\-t timl\-Util\-Reverse\-Endian32 (
\begin{DoxyParamCaption}
\item[{register uint32\-\_\-t}]{i}
\end{DoxyParamCaption}
)}}\label{group__util_ga16f8b9181ff6ce6d4b1f655a5eb4738e}


Reverse the 32 bit endian pattern. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em i} & Integer input \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Integer output 
\end{DoxyReturn}
\hypertarget{group__util_ga3cb2f6d77b727af3d819f75c6918c327}{\index{util@{util}!timl\-Util\-Scan\-J\-P\-E\-G@{timl\-Util\-Scan\-J\-P\-E\-G}}
\index{timl\-Util\-Scan\-J\-P\-E\-G@{timl\-Util\-Scan\-J\-P\-E\-G}!util@{util}}
\subsubsection[{timl\-Util\-Scan\-J\-P\-E\-G}]{\setlength{\rightskip}{0pt plus 5cm}char $\ast$$\ast$ timl\-Util\-Scan\-J\-P\-E\-G (
\begin{DoxyParamCaption}
\item[{const char $\ast$}]{dir\-Name, }
\item[{int $\ast$}]{image\-Num}
\end{DoxyParamCaption}
)}}\label{group__util_ga3cb2f6d77b727af3d819f75c6918c327}


Return an array of jpg image names in the directory. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em dir\-Name} & Directory name \\
\hline
\mbox{\tt out}  & {\em image\-Num} & Image number \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Image name array 
\end{DoxyReturn}
\hypertarget{group__util_ga0e3ab1684d55ae10ec96b1b7a58c2d0f}{\index{util@{util}!timl\-Util\-Sigmoid@{timl\-Util\-Sigmoid}}
\index{timl\-Util\-Sigmoid@{timl\-Util\-Sigmoid}!util@{util}}
\subsubsection[{timl\-Util\-Sigmoid}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Sigmoid (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{n, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga0e3ab1684d55ae10ec96b1b7a58c2d0f}


Sigmoid. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input \\
\hline
\mbox{\tt out}  & {\em y} & Output y = sigmoid(x) \\
\hline
\mbox{\tt in}  & {\em n} & Input size \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gac4ce5d2a827d4d0bddb092604dc22555}{\index{util@{util}!timl\-Util\-Sigmoid\-Derivative@{timl\-Util\-Sigmoid\-Derivative}}
\index{timl\-Util\-Sigmoid\-Derivative@{timl\-Util\-Sigmoid\-Derivative}!util@{util}}
\subsubsection[{timl\-Util\-Sigmoid\-Derivative}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Sigmoid\-Derivative (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{n, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_gac4ce5d2a827d4d0bddb092604dc22555}


Sigmoid derivative. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input \\
\hline
\mbox{\tt out}  & {\em y} & Outupt y = derivative of sigmoid(x) \\
\hline
\mbox{\tt in}  & {\em n} & Input size \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga223537dde56b8c21a9455ff8a635f71f}{\index{util@{util}!timl\-Util\-Softmax@{timl\-Util\-Softmax}}
\index{timl\-Util\-Softmax@{timl\-Util\-Softmax}!util@{util}}
\subsubsection[{timl\-Util\-Softmax}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Softmax (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{channel, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga223537dde56b8c21a9455ff8a635f71f}


Softmax function. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input \\
\hline
\mbox{\tt out}  & {\em y} & Outupt \\
\hline
\mbox{\tt in}  & {\em row} & x row size \\
\hline
\mbox{\tt in}  & {\em col} & x col size \\
\hline
\mbox{\tt in}  & {\em channel} & x channel size \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga158d5bed50c9d1aa04f3437ba4e4746c}{\index{util@{util}!timl\-Util\-Subtract@{timl\-Util\-Subtract}}
\index{timl\-Util\-Subtract@{timl\-Util\-Subtract}!util@{util}}
\subsubsection[{timl\-Util\-Subtract}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Subtract (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float}]{y, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga158d5bed50c9d1aa04f3437ba4e4746c}


Subtract operation. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in,out}  & {\em x} & x = x -\/ y \\
\hline
\mbox{\tt in}  & {\em y} & Subtract constant \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga26bb1805bd3475719324718c12cd5a0f}{\index{util@{util}!timl\-Util\-Tanh@{timl\-Util\-Tanh}}
\index{timl\-Util\-Tanh@{timl\-Util\-Tanh}!util@{util}}
\subsubsection[{timl\-Util\-Tanh}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Tanh (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{n, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga26bb1805bd3475719324718c12cd5a0f}


Tanh. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input \\
\hline
\mbox{\tt out}  & {\em y} & Output = tanh(x) \\
\hline
\mbox{\tt in}  & {\em n} & Input size \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga680fe5b84f1ce4712c74fc9c01b5dc82}{\index{util@{util}!timl\-Util\-Tanh\-Derivative@{timl\-Util\-Tanh\-Derivative}}
\index{timl\-Util\-Tanh\-Derivative@{timl\-Util\-Tanh\-Derivative}!util@{util}}
\subsubsection[{timl\-Util\-Tanh\-Derivative}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Tanh\-Derivative (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{float $\ast$}]{y, }
\item[{int}]{n, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga680fe5b84f1ce4712c74fc9c01b5dc82}


Tanh derivative. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input \\
\hline
\mbox{\tt out}  & {\em y} & Output = derivative of tanh(x) \\
\hline
\mbox{\tt in}  & {\em n} & Input size \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga6bc3609f73f6674134821cc002d7081f}{\index{util@{util}!timl\-Util\-Transform@{timl\-Util\-Transform}}
\index{timl\-Util\-Transform@{timl\-Util\-Transform}!util@{util}}
\subsubsection[{timl\-Util\-Transform}]{\setlength{\rightskip}{0pt plus 5cm}void timl\-Util\-Transform (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{data\-Out, }
\item[{float $\ast$}]{data\-In, }
\item[{float $\ast$}]{data\-Host, }
\item[{int}]{channel, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{row\-Offset, }
\item[{int}]{col\-Offset, }
\item[{int}]{row\-In, }
\item[{int}]{col\-In, }
\item[{float}]{scale, }
\item[{float $\ast$}]{mean, }
\item[{{\bf timl\-Util\-Mirror\-Type}}]{mirror\-Type, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga6bc3609f73f6674134821cc002d7081f}


Transform the raw input data with preprocessing. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em data\-Out} & Output data, i.\-e. the input feature map \\
\hline
\mbox{\tt out}  & {\em data\-In} & A copy of the input data \\
\hline
\mbox{\tt in}  & {\em data\-Host} & Input data \\
\hline
\mbox{\tt in}  & {\em channel} & Input feature map channel \\
\hline
\mbox{\tt in}  & {\em row} & Input feature map row \\
\hline
\mbox{\tt in}  & {\em col} & Input feature map col \\
\hline
\mbox{\tt in}  & {\em row\-Offset} & Row offset with regard to the raw input data \\
\hline
\mbox{\tt in}  & {\em col\-Offset} & Col offset with regard to the raw input data \\
\hline
\mbox{\tt in}  & {\em row\-In} & Raw input data row \\
\hline
\mbox{\tt in}  & {\em col\-In} & Raw input data col \\
\hline
\mbox{\tt in}  & {\em scale} & Scaling factor \\
\hline
\mbox{\tt in}  & {\em mean} & Input data mean \\
\hline
\mbox{\tt in}  & {\em mirror\-Type} & Whether to mirror the raw input data \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gae073107f6b111717bac95417ff80c85c}{\index{util@{util}!timl\-Util\-Undo\-Max\-Pooling@{timl\-Util\-Undo\-Max\-Pooling}}
\index{timl\-Util\-Undo\-Max\-Pooling@{timl\-Util\-Undo\-Max\-Pooling}!util@{util}}
\subsubsection[{timl\-Util\-Undo\-Max\-Pooling}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Undo\-Max\-Pooling (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{prev\-Delta, }
\item[{int $\ast$}]{max\-Index, }
\item[{float $\ast$}]{delta, }
\item[{int}]{dim, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_gae073107f6b111717bac95417ff80c85c}


Undo max pooling. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em prev\-Delta} & Previous layer delta \\
\hline
\mbox{\tt in}  & {\em max\-Index} & Max feature map value indices of the current layer \\
\hline
\mbox{\tt in}  & {\em delta} & Current layer delta \\
\hline
\mbox{\tt in}  & {\em dim} & Dimension of the current layer feature map \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga47ba59c5e11f31931e3fae5717b93450}{\index{util@{util}!timl\-Util\-Undo\-Mean\-Pooling@{timl\-Util\-Undo\-Mean\-Pooling}}
\index{timl\-Util\-Undo\-Mean\-Pooling@{timl\-Util\-Undo\-Mean\-Pooling}!util@{util}}
\subsubsection[{timl\-Util\-Undo\-Mean\-Pooling}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Undo\-Mean\-Pooling (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{prev\-Delta, }
\item[{float $\ast$}]{delta, }
\item[{int}]{row, }
\item[{int}]{col, }
\item[{int}]{channel, }
\item[{int}]{prev\-Row, }
\item[{int}]{prev\-Col, }
\item[{int}]{scale\-Row, }
\item[{int}]{scale\-Col, }
\item[{int}]{pad\-Up, }
\item[{int}]{pad\-Left, }
\item[{int}]{stride\-X, }
\item[{int}]{stride\-Y, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga47ba59c5e11f31931e3fae5717b93450}


Undo mean pooling. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt out}  & {\em prev\-Delta} & Previous layer delta \\
\hline
\mbox{\tt in}  & {\em delta} & Current feature map delta \\
\hline
\mbox{\tt in}  & {\em row} & Current feature map row \\
\hline
\mbox{\tt in}  & {\em col} & Current feature map col \\
\hline
\mbox{\tt in}  & {\em channel} & Current feature map channel \\
\hline
\mbox{\tt in}  & {\em prev\-Row} & Previous feature map row \\
\hline
\mbox{\tt in}  & {\em prev\-Col} & Previous feature map col \\
\hline
\mbox{\tt in}  & {\em scale\-Row} & Scaling window row size \\
\hline
\mbox{\tt in}  & {\em scale\-Col} & Scaling window col size \\
\hline
\mbox{\tt in}  & {\em pad\-Up} & Upper border padding for the previous feature map \\
\hline
\mbox{\tt in}  & {\em pad\-Left} & Left border padding for the previous feature map \\
\hline
\mbox{\tt in}  & {\em stride\-X} & Window stride in x direction \\
\hline
\mbox{\tt in}  & {\em stride\-Y} & Window stride in y direction \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga7e53789a132ed94665d66a10dd9ff76c}{\index{util@{util}!timl\-Util\-Unmasking@{timl\-Util\-Unmasking}}
\index{timl\-Util\-Unmasking@{timl\-Util\-Unmasking}!util@{util}}
\subsubsection[{timl\-Util\-Unmasking}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Unmasking (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{input\-Delta, }
\item[{float $\ast$}]{output\-Delta, }
\item[{int $\ast$}]{mask, }
\item[{int}]{dim, }
\item[{float}]{prob, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga7e53789a132ed94665d66a10dd9ff76c}


Masking feature maps. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em input\-Delta} & Current feature map delta \\
\hline
\mbox{\tt out}  & {\em output\-Delta} & Previous feature map delta \\
\hline
\mbox{\tt in}  & {\em mask} & Masking vector \\
\hline
\mbox{\tt in}  & {\em dim} & Dimension of the masking vector \\
\hline
\mbox{\tt in}  & {\em prob} & Dropout probability \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga80375ed4d8c895a5373c0ea5bea7c90c}{\index{util@{util}!timl\-Util\-Vector\-Max\-Float@{timl\-Util\-Vector\-Max\-Float}}
\index{timl\-Util\-Vector\-Max\-Float@{timl\-Util\-Vector\-Max\-Float}!util@{util}}
\subsubsection[{timl\-Util\-Vector\-Max\-Float}]{\setlength{\rightskip}{0pt plus 5cm}float timl\-Util\-Vector\-Max\-Float (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{int}]{n, }
\item[{int}]{inc}
\end{DoxyParamCaption}
)}}\label{group__util_ga80375ed4d8c895a5373c0ea5bea7c90c}


Return the max value in the array. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input array \\
\hline
\mbox{\tt in}  & {\em n} & Array size \\
\hline
\mbox{\tt in}  & {\em inc} & Increment \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Max value 
\end{DoxyReturn}
\hypertarget{group__util_ga2e09d42235ce01dc8d951cac92ccce28}{\index{util@{util}!timl\-Util\-Vector\-Max\-Index\-Float@{timl\-Util\-Vector\-Max\-Index\-Float}}
\index{timl\-Util\-Vector\-Max\-Index\-Float@{timl\-Util\-Vector\-Max\-Index\-Float}!util@{util}}
\subsubsection[{timl\-Util\-Vector\-Max\-Index\-Float}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Vector\-Max\-Index\-Float (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{x, }
\item[{int}]{n, }
\item[{int}]{inc}
\end{DoxyParamCaption}
)}}\label{group__util_ga2e09d42235ce01dc8d951cac92ccce28}


Return the max value index in the array. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em x} & Input array \\
\hline
\mbox{\tt in}  & {\em n} & Array size \\
\hline
\mbox{\tt in}  & {\em inc} & Increment \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Max value index 
\end{DoxyReturn}
\hypertarget{group__util_ga4c8737cc28dfcafb340a06869cb06c6d}{\index{util@{util}!timl\-Util\-Vector\-Reset\-Float@{timl\-Util\-Vector\-Reset\-Float}}
\index{timl\-Util\-Vector\-Reset\-Float@{timl\-Util\-Vector\-Reset\-Float}!util@{util}}
\subsubsection[{timl\-Util\-Vector\-Reset\-Float}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Vector\-Reset\-Float (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{int}]{m, }
\item[{float}]{val, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga4c8737cc28dfcafb340a06869cb06c6d}


Reset a float vector. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in,out}  & {\em a} & Vector \\
\hline
\mbox{\tt in}  & {\em m} & Vector size \\
\hline
\mbox{\tt in}  & {\em val} & Value \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga105ed091f1ed14bc4542117639799727}{\index{util@{util}!timl\-Util\-Vector\-Reset\-Int@{timl\-Util\-Vector\-Reset\-Int}}
\index{timl\-Util\-Vector\-Reset\-Int@{timl\-Util\-Vector\-Reset\-Int}!util@{util}}
\subsubsection[{timl\-Util\-Vector\-Reset\-Int}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Vector\-Reset\-Int (
\begin{DoxyParamCaption}
\item[{int $\ast$}]{a, }
\item[{int}]{m, }
\item[{int}]{val, }
\item[{int}]{device\-Id, }
\item[{int}]{thread\-Id}
\end{DoxyParamCaption}
)}}\label{group__util_ga105ed091f1ed14bc4542117639799727}


Reset an int vector. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in,out}  & {\em a} & Vector \\
\hline
\mbox{\tt in}  & {\em m} & Vector size \\
\hline
\mbox{\tt in}  & {\em val} & Value \\
\hline
\mbox{\tt in}  & {\em device\-Id} & Device id \\
\hline
\mbox{\tt in}  & {\em thread\-Id} & Thread id \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_gadbfd41f459cef267ff705fbed1a684de}{\index{util@{util}!timl\-Util\-Vector\-Sort\-Float@{timl\-Util\-Vector\-Sort\-Float}}
\index{timl\-Util\-Vector\-Sort\-Float@{timl\-Util\-Vector\-Sort\-Float}!util@{util}}
\subsubsection[{timl\-Util\-Vector\-Sort\-Float}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Vector\-Sort\-Float (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{int}]{n}
\end{DoxyParamCaption}
)}}\label{group__util_gadbfd41f459cef267ff705fbed1a684de}


Sort an array in descending order. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in,out}  & {\em a} & Array \\
\hline
\mbox{\tt in}  & {\em n} & Array size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga7adedb39838d1a724329c2f05e70d2bc}{\index{util@{util}!timl\-Util\-Vector\-Sort\-Index\-Float@{timl\-Util\-Vector\-Sort\-Index\-Float}}
\index{timl\-Util\-Vector\-Sort\-Index\-Float@{timl\-Util\-Vector\-Sort\-Index\-Float}!util@{util}}
\subsubsection[{timl\-Util\-Vector\-Sort\-Index\-Float}]{\setlength{\rightskip}{0pt plus 5cm}int timl\-Util\-Vector\-Sort\-Index\-Float (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{int $\ast$}]{index, }
\item[{int}]{n}
\end{DoxyParamCaption}
)}}\label{group__util_ga7adedb39838d1a724329c2f05e70d2bc}


Sort an array in descending order and return the indices of the original elements in the sorted array. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in}  & {\em a} & Array \\
\hline
\mbox{\tt out}  & {\em index} & Sorted index \\
\hline
\mbox{\tt in}  & {\em n} & Array size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Error code 
\end{DoxyReturn}
\hypertarget{group__util_ga50c739176cce0504f24f414d1abe03de}{\index{util@{util}!timl\-Util\-Vector\-Sum\-Float@{timl\-Util\-Vector\-Sum\-Float}}
\index{timl\-Util\-Vector\-Sum\-Float@{timl\-Util\-Vector\-Sum\-Float}!util@{util}}
\subsubsection[{timl\-Util\-Vector\-Sum\-Float}]{\setlength{\rightskip}{0pt plus 5cm}float timl\-Util\-Vector\-Sum\-Float (
\begin{DoxyParamCaption}
\item[{float $\ast$}]{a, }
\item[{int}]{n}
\end{DoxyParamCaption}
)}}\label{group__util_ga50c739176cce0504f24f414d1abe03de}


Calculate the sum of a float vector. 


\begin{DoxyParams}[1]{Parameters}
\mbox{\tt in,out}  & {\em a} & Vector \\
\hline
\mbox{\tt in}  & {\em n} & Vector size \\
\hline
\end{DoxyParams}
\begin{DoxyReturn}{Returns}
Sum 
\end{DoxyReturn}
